'From Squeak3.8alpha of ''17 July 2004'' [latest update: #6313] on 9 October 2004 at 8:05:48 pm'!
"Change Set:		Closures-ajh
Date:			14 May 2004
Author:			Anthony Hannan <ajh18@cornell.edu>

v3: moved some more stuff into the image 
       (ClosureCompilerChanges1-md)

This adds BlockClosures to the image.  Use the closure compiler in Compiler-ajh to create them.

md: removed macroBenchMarcmethod, removed 
ClassDescription>>printMethodChunk:withPreamble:on:
which did not work
"!

Inspector subclass: #ClosureEnvInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-Debugger'!

!ProtoObject methodsFor: 'testing' stamp: 'ajh 12/4/2001 12:44'!
ifNotNil: ifNotNilBlock
	"Evaluate the block, unless I'm == nil (q.v.)"

	^ ifNotNilBlock valueWithPossibleArgs: {self}! !

!ProtoObject methodsFor: 'compiler prims' stamp: 'ajh 7/2/2004 13:42'!
privGetField: index
	"The compiler generates this message when accessing to instance variables of objects other than the receiver.  Do not override or change this unless you also modify the compiler and recompile everything"

	<primitive: 73>
	^ self basicAt: index - self class instSize! !

!ProtoObject methodsFor: 'compiler prims' stamp: 'ajh 7/2/2004 13:44'!
privRemoteReturnTo: contextTag
	"Generated from compiler to return to the home of a block.  self is the value return and contextTag is the tag of the home context.  Do not override or change this unless you also modify the compiler and recompile everything"

	contextTag return: self! !

!ProtoObject methodsFor: 'compiler prims' stamp: 'ajh 7/2/2004 13:48'!
privSetField: index put: value 

	<primitive: 74>
	^ self basicAt: index - self class instSize put: value! !

!ProtoObject methodsFor: 'compiler prims' stamp: 'ajh 7/2/2004 13:58'!
privSetInHolder: valueHolder
	"The compiler generates this message to place values in global variables.  Do not override or change this unless you also modify the compiler and recompile everything"

	valueHolder value: self.
	^ self! !

!ProtoObject methodsFor: 'compiler prims' stamp: 'ajh 7/3/2004 15:14'!
privStoreIn: object field: index
	"The compiler generates this message when assigning to instance variables of objects that have been captured by a block closure.  Do not override or change this unless you also modify the compiler and recompile everything"

	object privSetField: index put: self! !


!Object methodsFor: 'binding' stamp: 'ajh 2/6/2003 13:24'!
hasLiteralSuchThat: testBlock
	"This is the end of the imbedded structure path so return false."

	^ false! !

!Object methodsFor: 'binding' stamp: 'ajh 1/31/2003 12:04'!
hasLiteralThorough: literal
	"Answer true if literal is identical to any literal in this array, even if imbedded in further structures.  This is the end of the imbedded structure path so return false."

	^ false! !

!Object methodsFor: 'error handling' stamp: 'ajh 7/7/2004 14:25'!
handles: exception
	"This method exists in case a non exception class is the first arg in an on:do: (for instance using a exception class that is not loaded). We prefer this to raising an error during error handling itself. Also, semantically it makes sense that the exception handler is not active if its exception class is not loaded"

	^ false! !

!Object methodsFor: 'message handling' stamp: 'ajh 7/19/2004 14:39'!
executeMethod: compiledMethod
	"Execute compiledMethod against the receiver with no args"

	"<primitive: 189>" "uncomment once prim 189 is in VM"
	^ self withArgs: #() executeMethod: compiledMethod! !

!Object methodsFor: 'message handling' stamp: 'ajh 7/19/2004 14:39'!
with: arg1 executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and arg1"

	"<primitive: 189>" "uncomment once prim 189 is in VM"
	^ self withArgs: {arg1} executeMethod: compiledMethod! !

!Object methodsFor: 'message handling' stamp: 'ajh 7/19/2004 14:39'!
with: arg1 with: arg2 executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and arg1 & arg2"

	"<primitive: 189>" "uncomment once prim 189 is in VM"
	^ self withArgs: {arg1. arg2} executeMethod: compiledMethod! !

!Object methodsFor: 'message handling' stamp: 'ajh 7/19/2004 14:39'!
with: arg1 with: arg2 with: arg3 executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and arg1, arg2, & arg3"

	"<primitive: 189>" "uncomment once prim 189 is in VM"
	^ self withArgs: {arg1. arg2. arg3} executeMethod: compiledMethod! !

!Object methodsFor: 'message handling' stamp: 'ajh 7/19/2004 14:39'!
with: arg1 with: arg2 with: arg3 with: arg4 executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and arg1, arg2, arg3, & arg4"

	"<primitive: 189>" "uncomment once prim 189 is in VM"
	^ self withArgs: {arg1. arg2. arg3. arg4} executeMethod: compiledMethod! !


!Array methodsFor: 'private' stamp: 'ajh 2/6/2003 13:22'!
hasLiteralSuchThat: testBlock

	| lit |
	1 to: self size do: [:index |
		(testBlock value: (lit _ self at: index)) ifTrue: [^ true].
		(lit hasLiteralSuchThat: testBlock) ifTrue: [^ true]].
	^ false! !

!Array methodsFor: 'private' stamp: 'ajh 1/31/2003 12:02'!
hasLiteralThorough: literal
	"Answer true if literal is identical to any literal in this array, even if imbedded in further array structures or closure methods"

	| lit |
	1 to: self size do: [:index |
		(lit _ self at: index) == literal ifTrue: [^ true].
		(lit hasLiteralThorough: literal) ifTrue: [^ true]].
	^ false! !


!Behavior methodsFor: 'accessing' stamp: 'ajh 3/13/2003 21:13'!
decompilerClass
	"Answer a decompiler class appropriate for compiled methods of this class."

	^ Preferences compileBlocksAsClosures
		ifTrue: [Decompiler2]
		ifFalse: [Decompiler]! !

!Behavior methodsFor: 'testing method dictionary' stamp: 'ajh 2/3/2003 17:40'!
thoroughWhichSelectorsReferTo: literal special: specialFlag byte: specialByte
	"Answer a set of selectors whose methods access the argument as a 
	literal. Dives into the compact literal notation, making it slow but 
	thorough "

	| who |
	who _ Set new.
	self selectorsAndMethodsDo:
		[:sel :method |
		((method hasLiteralThorough: literal) or: [specialFlag and: [method scanFor: specialByte]])
			ifTrue:
				[((literal isVariableBinding) not
					or: [method sendsToSuper not
					or: [method literals last ~= literal]])
						ifTrue: [who add: sel]]].
	^ who! !

!Behavior methodsFor: 'testing method dictionary' stamp: 'ajh 2/3/2003 17:36'!
whichSelectorsReferTo: literal special: specialFlag byte: specialByte
	"Answer a set of selectors whose methods access the argument as a literal."

	| who |
	who _ Set new.
	self selectorsAndMethodsDo: 
		[:sel :method |
		((method hasLiteralThorough: literal) or: [specialFlag and: [method scanFor: specialByte]])
			ifTrue:
				[((literal isVariableBinding) not
					or: [method sendsToSuper not
					or: [method literals last ~= literal]])
						ifTrue: [who add: sel]]].
	^ who! !


!Class methodsFor: 'compiling' stamp: 'ajh 6/18/2002 14:48'!
holder

	^ Smalltalk associationAt: name ifAbsent: [nil -> self]! !


!ClosureEnvInspector methodsFor: 'accessing' stamp: 'ajh 7/7/2004 16:13'!
doItContext
	"Use my context. May be nil, in which case doItReceiver will be the context"

	^ context! !

!ClosureEnvInspector methodsFor: 'accessing' stamp: 'ajh 7/7/2004 16:12'!
doItReceiver
	"My doItContext will take precedence"

	^ object! !

!ClosureEnvInspector methodsFor: 'accessing' stamp: 'ajh 7/7/2004 16:05'!
fieldList 
	"Refer to the comment in Inspector|fieldList."

	object == nil ifTrue: [^ #('thisEnv')].
	^ #('thisEnv' 'all free vars'), self freeNames! !

!ClosureEnvInspector methodsFor: 'accessing' stamp: 'ajh 7/7/2004 16:35'!
freeNames

	context ifNil: [^ (1 to: object size) collect: [:i | i printString]].

	^ context freeNames! !

!ClosureEnvInspector methodsFor: 'accessing' stamp: 'ajh 7/7/2004 16:34'!
freeNamesAndValues

	context ifNil: [
		| stream |
		stream _ '' writeStream.
		1 to: object size do: [:i |
			stream print: i; nextPut: $:; space; tab.
			(object at: i) printOn: stream.
			stream cr].
		^ stream contents
	].

	^ context freeNamesAndValues! !

!ClosureEnvInspector methodsFor: 'accessing' stamp: 'ajh 7/8/2004 20:12'!
object: anObject 
	"Same as super, except always update fields even if the object is the same, because the same closureEnvironment (object) can have different free vars depending on the context."

	| oldIndex |
	oldIndex _ selectionIndex <= 2 ifTrue: [selectionIndex] ifFalse: [0].
	self inspect: anObject.
	oldIndex _ oldIndex min: self fieldList size.
	self changed: #inspectObject.
	oldIndex > 0
		ifTrue: [self toggleIndex: oldIndex].
	self changed: #fieldList.
	self changed: #contents.
! !

!ClosureEnvInspector methodsFor: 'selecting' stamp: 'ajh 7/7/2004 16:50'!
accept: aString

	| result |
	selectionIndex <= 2 ifTrue: [^ false].
	context ifNil: [^ super accept: aString].

	self eval: self selectedSlotName , ' _ ' , aString ifFail: [^ false].
	self update.
	^ true
! !

!ClosureEnvInspector methodsFor: 'selecting' stamp: 'ajh 7/7/2004 16:57'!
eval: string ifFail: block

	^ self doItReceiver class evaluatorClass new
		evaluate2: (ReadStream on: string)
		in: self doItContext
		to: self doItReceiver
		notifying: nil	"fix this"
		ifFail:  block
		logged: false! !

!ClosureEnvInspector methodsFor: 'selecting' stamp: 'ajh 7/7/2004 16:46'!
replaceSelectionValue: anObject 
	"Refer to the comment in Inspector|replaceSelectionValue:."

	object at: selectionIndex - 2 put: anObject! !

!ClosureEnvInspector methodsFor: 'selecting' stamp: 'ajh 7/7/2004 17:41'!
selection 
	"Refer to the comment in Inspector|selection."

	selectionIndex = 0 ifTrue:[^ ''].
	selectionIndex = 1 ifTrue: [^ object].
	selectionIndex = 2 ifTrue: [^ self freeNamesAndValues].
	context ifNil: [^ object at: selectionIndex - 2].
	^ self eval: (self freeNames at: selectionIndex - 2)
		ifFail: [self error: 'bug']! !


!CompiledMethod methodsFor: 'initialize-release' stamp: 'ajh 6/28/2004 14:23'!
isBlockMethod: bool
	"Use the sign bit in the header to mark methods that are sub-methods of an outer method. The outer method will be held in my last literal."

	self objectAt: 1 put: (bool
		ifTrue: [self header bitOr: 1 << 29]
		ifFalse: [self header bitAnd: (1 << 29) bitInvert])! !

!CompiledMethod methodsFor: 'initialize-release' stamp: 'ajh 6/28/2004 14:26'!
isClosureCompiled: bool
	"Use the sign bit in the header to mark methods that have been compiled using the new closure compiler (Parser2)."

	self objectAt: 1 put: (bool
		ifTrue: [(self header bitOr: 1 << 30) as31BitSmallInt]
		ifFalse: [(self header bitAnd: (1 << 30) bitInvert) as31BitSmallInt])! !

!CompiledMethod methodsFor: 'accessing' stamp: 'ajh 3/10/2003 14:02'!
method
	"polymorphic with closure"

	^ self! !

!CompiledMethod methodsFor: 'comparing' stamp: 'ajh 6/28/2004 16:49'!
= method
	"Answer whether the receiver implements the same code as the argument, method."

	| myLits otherLits |
	(method isKindOf: CompiledMethod) ifFalse: [^ false].
	self header = method header ifFalse: [^ false].
	self endPC = method endPC ifFalse: [^ false].
	self initialPC to: self endPC do:
		[:i | (self at: i) = (method at: i) ifFalse: [^ false]].
	(myLits _ self literals) = (otherLits _ method literals) ifFalse:
		[myLits size = otherLits size ifFalse: [^ false].
		"Dont bother checking FFI and named primitives"
		(#(117 120) includes: self primitive) ifTrue: [^ true].
		myLits with: otherLits do:
			[:lit1 :lit2 | lit1 = lit2 ifFalse:
			[(lit1 isVariableBinding)
			ifTrue:
				["Associations match if value is equal, since associations
				used for super may have key = nil or name of class."
				lit1 value == lit2 value ifFalse: [^ false]]
			ifFalse:
				[(lit1 isMemberOf: Float)
				ifTrue:
					["Floats match if values are close, due to roundoff error."
					(lit1 closeTo: lit2) ifFalse: [^ false]]
				ifFalse:
					["any other discrepancy is a failure"
					^ false]]]]].
	^ true! !

!CompiledMethod methodsFor: 'printing' stamp: 'ajh 6/28/2004 13:54'!
headerDescription
	"Answer a description containing the information about the form of the 
	receiver and the form of the context needed to run the receiver."

	| s |
	s _ '' writeStream.
	self header printOn: s.
	s cr; nextPutAll: '"primitive: '.
	self primitive printOn: s.
	s cr; nextPutAll: ' numArgs: '.
	self numArgs printOn: s.
	s cr; nextPutAll: ' numTemps: '.
	self numTemps printOn: s.
	s cr; nextPutAll: ' numLiterals: '.
	self numLiterals printOn: s.
	s cr; nextPutAll: ' frameSize: '.
	self frameSize printOn: s.
	s cr; nextPutAll: ' isClosureCompiled: '.
	self isClosureCompiled printOn: s.
	s cr; nextPutAll: ' isBlockMethod: '.
	self isBlockMethod printOn: s.
	s nextPut: $"; cr.
	^ s contents! !

!CompiledMethod methodsFor: 'literals' stamp: 'ajh 5/20/2004 01:29'!
allEmbeddedBlockMethods

	| set |
	set _ OrderedCollection new.
	1 to: self numLiterals do: [:i |  | lit |
		lit _ self literalAt: i.
		(lit isKindOf: CompiledMethod) ifTrue: [
			set add: lit.
			set addAll: lit allEmbeddedBlockMethods.
		] ifFalse: [(lit isKindOf: BlockClosure) ifTrue: [
			set add: lit method.
			set addAll: lit method allEmbeddedBlockMethods
		]].
	].
	^ set! !

!CompiledMethod methodsFor: 'literals' stamp: 'ajh 5/30/2003 01:31'!
embeddedBlockMethods

	| set |
	set _ OrderedCollection new.
	1 to: self numLiterals do: [:i |  | lit |
		lit _ self literalAt: i.
		(lit isKindOf: CompiledMethod) ifTrue: [
			set add: lit.
		] ifFalse: [(lit isKindOf: BlockClosure) ifTrue: [
			set add: lit method.
		]].
	].
	^ set! !

!CompiledMethod methodsFor: 'literals' stamp: 'ajh 2/6/2003 13:25'!
hasLiteralSuchThat: testBlock
	"Answer true if testBlock returns true for any literal in this method, even if imbedded."

	| lit |
	2 to: self numLiterals + 1 do: 
		[:index | 
		(testBlock value: (lit _ self objectAt: index)) ifTrue: [^ true].
		(lit hasLiteralSuchThat: testBlock) ifTrue: [^ true]].
	^ false! !

!CompiledMethod methodsFor: 'literals' stamp: 'ajh 1/31/2003 12:05'!
hasLiteralThorough: literal
	"Answer true if any literal in this method is literal,
	even if embedded in array structure."

	| lit |
	2 to: self numLiterals + 1 do: 
		[:index | 
		(lit _ self objectAt: index) == literal ifTrue: [^ true].
		(lit hasLiteralThorough: literal) ifTrue: [^ true]].
	^ false! !

!CompiledMethod methodsFor: 'scanning' stamp: 'ajh 7/7/2004 18:20'!
readsField: varIndex 
	"Answer whether the receiver loads the instance variable indexed by the argument."

	self allEmbeddedBlockMethods do: [:meth |
		| scanner catcher instr scan |
		scanner _ meth scanner.
		catcher _ MessageCatcher new.
		[scanner atEnd] whileFalse: [
			instr _ scanner interpretNextInstructionFor: catcher.
			(instr selector = #send:super:numArgs: and: [instr argument = #privGetField:]) ifTrue: [
				scan _ scanner copy.
				scan pc: scan previousPc. scan pc: scan previousPc.
				instr _ scan interpretNextInstructionFor: catcher.
				(instr selector = #pushConstant: and: [instr argument = varIndex])
					ifTrue: [^ true]
			].
		].
	].
	self isReturnField ifTrue: [^ self returnField + 1 = varIndex].
	varIndex <= 16 ifTrue: [^ self scanFor: varIndex - 1].
	varIndex <= 64 ifTrue: [^ self scanLongLoad: varIndex - 1].
	^ self scanVeryLongLoad: 64 offset: varIndex - 1! !

!CompiledMethod methodsFor: 'scanning' stamp: 'ajh 7/2/2004 13:44'!
remoteReturns
	"For closure methods only"

	^ self messages includes: #privRemoteReturnTo:! !

!CompiledMethod methodsFor: 'scanning' stamp: 'ajh 7/7/2004 18:20'!
writesField: field 
	"Answer whether the receiver stores into the instance variable indexed by the argument."

	self allEmbeddedBlockMethods do: [:meth |
		| scanner catcher instr scan |
		scanner _ meth scanner.
		catcher _ MessageCatcher new.
		[scanner atEnd] whileFalse: [
			instr _ scanner interpretNextInstructionFor: catcher.
			(instr selector = #send:super:numArgs: and: [instr argument = #privStoreIn:field:]) ifTrue: [
				scan _ scanner copy.
				scan pc: scan previousPc. scan pc: scan previousPc.
				instr _ scan interpretNextInstructionFor: catcher.
				(instr selector = #pushConstant: and: [instr argument = field])
					ifTrue: [^ true]
			].
		].
	].
	self isQuick ifTrue: [^ false].
	field <= 8 ifTrue:
		[^ (self scanFor: 96 + field - 1) or: [self scanLongStore: field - 1]].
	field <= 64 ifTrue:
		[^ self scanLongStore: field - 1].
	^ self scanVeryLongStore: 160 offset: field - 1! !

!CompiledMethod methodsFor: 'source code management' stamp: 'ajh 6/28/2004 15:03'!
setMySourcePointer: srcPointer

	srcPointer = 0 ifTrue: [
		self at: self size put: 0.
		^self].
	(srcPointer between: 16r1000000 and: 16r4FFFFFF) ifFalse: [self error: 'Source pointer out of range'].
	self at: self size put: (srcPointer bitShift: -24) + 251.
	1 to: 3 do: [:i |
		self at: self size-i put: ((srcPointer bitShift: (i-3)*8) bitAnd: 16rFF)]! !

!CompiledMethod methodsFor: 'source code management' stamp: 'ajh 6/28/2004 15:04'!
setSourcePointer: srcPointer

	self setMySourcePointer: srcPointer.
	self embeddedBlockMethods do: [:m |
		m setSourcePointer: srcPointer].
! !

!CompiledMethod methodsFor: 'decompiling' stamp: 'ajh 6/28/2004 09:59'!
isBlockMethod
	"Is this a sub-method (embedded block's method) of another method. If so the last literal points to its outer method"

	^ (self header bitAnd: 1 << 29) ~= 0! !

!CompiledMethod methodsFor: 'decompiling' stamp: 'ajh 2/9/2003 13:11'!
isClosureCompiled
	"Return true if this method was compiled with the new closure compiler, Parser2 (compiled while Preference compileBlocksAsClosures was true).  Return false if it was compiled with the old compiler."

	^ self header < 0! !

!CompiledMethod methodsFor: 'decompiling' stamp: 'ajh 2/6/2003 12:48'!
searchImageForHomeMethod

	Smalltalk allObjectsDo: [:obj |
		obj class == CompiledMethod ifTrue: [
			(obj pointsTo: self) ifTrue: [^ obj searchImageForHomeMethod]
		] ifFalse: [obj class == BlockClosure ifTrue: [
			(obj method == self and: [obj size = 0])
				ifTrue: [^ obj searchImageForHomeMethod]
		]]
	].
	^ self  "must be a loner block method"! !

!CompiledMethod methodsFor: 'closure creation' stamp: 'ajh 6/26/2004 18:49'!
createBlock: env

	^ BlockClosure new
		env: env;
		method: self! !


!CompiledMethod class methodsFor: 'instance creation' stamp: 'ajh 6/28/2004 10:04'!
newBytes: numberOfBytes trailerBytes: trailer nArgs: nArgs nTemps: nTemps nStack: stackSize nLits: nLits primitive: primitiveIndex
	"Answer an instance of me. The header is specified by the message 
	arguments. The remaining parts are not as yet determined."
	| largeBit primBits method |
	nTemps > 64 ifTrue:
		[^ self error: 'Cannot compile -- too many temporary variables'].	
	largeBit _ (nTemps + stackSize) > SmallFrame ifTrue: [1] ifFalse: [0].
	primBits _ primitiveIndex <= 16r1FF
		ifTrue: [primitiveIndex]
		ifFalse: ["For now the high bit of primitive no. is in the 29th bit of header"
				primitiveIndex > 16r3FF ifTrue: [self error: 'prim num too large'].
				(primitiveIndex bitAnd: 16r1FF) + ((primitiveIndex bitAnd: 16r200) bitShift: 19)].
	method _ self newMethod: numberOfBytes + trailer size
		header: (nArgs bitShift: 24) +
				(nTemps bitShift: 18) +
				(largeBit bitShift: 17) +
				(nLits bitShift: 9) +
				primBits.
	1 to: trailer size do:  "Copy the source code trailer to the end"
		[:i | method at: method size - trailer size + i put: (trailer at: i)].
	^ method! !


!ContextPart methodsFor: 'debugger access' stamp: 'ajh 7/8/2004 19:09'!
tempNames
	"Answer an OrderedCollection of the names of the receiver's temporary 
	variables, which are strings."

	"unused temps at end are not included in method. On the other hand, extra temps such as to:do: loop limit are added to method"
	| tempNames n |
	tempNames _ self methodNode tempNames.
	n _ self method numTemps.
	tempNames size = n ifTrue: [^ tempNames].
	tempNames size > n ifTrue: [^ tempNames first: n].
	tempNames size + 1 to: n do: [:i |
		tempNames _ tempNames copyWith: 't' , i printString].
	^ tempNames! !

!ContextPart methodsFor: 'system simulation' stamp: 'ajh 4/15/2003 10:01'!
runSimulated: aBlock contextAtEachStep: block2
	"Simulate the execution of the argument, aBlock, until it ends. aBlock 
	MUST NOT contain an '^'. Evaluate block2 with the current context 
	prior to each instruction executed. Answer the simulated value of aBlock."

	| current |
	(aBlock isBlock and: [aBlock hasMethodReturn])
		ifTrue: [self error: 'simulation of blocks with ^ can run loose'].
	current _ aBlock asContext.
	current privSender: self.
	[current == self]
		whileFalse:
			[block2 value: current.
			current _ current step].
	^ self pop! !

!ContextPart methodsFor: 'private' stamp: 'ajh 7/7/2004 13:11'!
doPrimitive: primitiveIndex method: meth receiver: receiver args: arguments 
	"Simulate a primitive method whose index is primitiveIndex.  The
	simulated receiver and arguments are given as arguments to this message."

	| value |
	<primitive: 19> "Simulation guard"
	"If successful, push result and return resuming context,
		else ^ PrimitiveFailToken"
	(primitiveIndex = 19) ifTrue:[
		Debugger 
			openContext: self
			label:'Code simulation error'
			contents: nil].

	(primitiveIndex = 80 and: [receiver isKindOf: ContextPart])
		ifTrue: [^self push: ((BlockContext newForMethod: receiver home method)
						home: receiver home
						startpc: pc + 2
						nargs: (arguments at: 1))].
	(primitiveIndex = 81 and: [receiver isMemberOf: BlockContext])
		ifTrue: [^receiver pushArgs: arguments from: self].
	primitiveIndex = 83 "afr 9/11/1998 19:50"
		ifTrue: [^ self send: arguments first to: receiver
					with: arguments allButFirst
					super: false].
	primitiveIndex = 84 "afr 9/11/1998 19:50"
		ifTrue: [^ self send: arguments first to: receiver
					with: (arguments at: 2)
					super: false].
	primitiveIndex = 186 ifTrue: [ "closure value"
		| m |
		m _ receiver method.
		arguments size = m numArgs ifFalse: [^ PrimitiveFailToken].
		^ self activateMethod: m
			withArgs: arguments
			receiver: receiver
			class: receiver class].
	primitiveIndex = 187 ifTrue: [ "closure valueWithArguments:"
		| m args |
		m _ receiver method.
		args _ arguments first.
		args size = m numArgs ifFalse: [^ PrimitiveFailToken].
		^ self activateMethod: m
			withArgs: args
			receiver: receiver
			class: receiver class].
	primitiveIndex = 188 ifTrue: [ "object withArgs:executeMethod:"
		| m args |
		args _ arguments first.
		m _ arguments second.
		args size = m numArgs ifFalse: [^ PrimitiveFailToken].
		^ self activateMethod: m
			withArgs: args
			receiver: receiver
			class: receiver class].
	arguments size > 6 ifTrue: [^ PrimitiveFailToken].
	primitiveIndex = 117 
		ifTrue:[value _ self tryNamedPrimitiveIn: meth for: receiver withArgs: arguments]
		ifFalse:[value _ receiver tryPrimitive: primitiveIndex withArgs: arguments].
	value == PrimitiveFailToken
		ifTrue: [^ PrimitiveFailToken]
		ifFalse: [^ self push: value]! !

!ContextPart methodsFor: 'query' stamp: 'ajh 1/31/2003 21:53'!
isClosureContext

	^ false! !


!ContextVariablesInspector methodsFor: 'accessing' stamp: 'ajh 7/7/2004 15:15'!
fieldList 
	"Refer to the comment in Inspector|fieldList."

	| fields |
	object == nil ifTrue: [^Array with: 'thisContext'].
	fields _ (Array with: 'thisContext' with: 'all temp vars') , object tempNames.
	object myEnv ifNotNil: [
		fields _ fields, object capturedTempNames].
	^ fields! !

!ContextVariablesInspector methodsFor: 'selecting' stamp: 'ajh 7/7/2004 18:04'!
replaceSelectionValue: anObject 
	"Refer to the comment in Inspector|replaceSelectionValue:."

	| numTemps |
	selectionIndex <= 2 ifTrue: [^ self].
	numTemps _ object method numTemps.
	selectionIndex - 2 <= object method numTemps ifTrue: [
		^ object tempAt: selectionIndex - 2 put: anObject].
	^ object myEnv at: selectionIndex - 2 - numTemps put: anObject! !

!ContextVariablesInspector methodsFor: 'selecting' stamp: 'ajh 7/7/2004 15:19'!
selection 
	"Refer to the comment in Inspector|selection."

	| numTemps |
	selectionIndex = 0 ifTrue:[^''].
	selectionIndex = 1 ifTrue: [^object].
	selectionIndex = 2 ifTrue: [^ object tempsAndValues].
	numTemps _ object method numTemps.
	selectionIndex - 2 <= object method numTemps ifTrue: [
		^ object tempAt: selectionIndex - 2].
	^ object myEnv at: selectionIndex - 2 - numTemps! !


!MessageTally methodsFor: 'initialize-release' stamp: 'ajh 2/9/2003 20:21'!
spyEvery: millisecs on: aBlock 
	"Create a spy and spy on the given block at the specified rate."

	| myDelay value startTime time0 |
	(aBlock isMemberOf: BlockContext)
		ifTrue: [self class: aBlock receiver class method: aBlock method]
		ifFalse: [self class: aBlock class method: aBlock method].
	"set up the probe"
	ObservedProcess _ Processor activeProcess.
	myDelay := Delay forMilliseconds: millisecs.
	time0 := Time millisecondClockValue.
	gcStats _ Smalltalk getVMParameters.
	Timer :=
		[[true] whileTrue: 
			[startTime := Time millisecondClockValue.
			myDelay wait.
			self tally: ObservedProcess suspendedContext
				"tally can be > 1 if ran a long primitive"
				by: (Time millisecondClockValue - startTime) // millisecs].
		nil] newProcess.
	Timer priority: Processor userInterruptPriority.
		"activate the probe and evaluate the block"
	Timer resume.
	value := aBlock value.
	"Collect gc statistics"
	Smalltalk getVMParameters keysAndValuesDo:
		[:idx :gcVal| gcStats at: idx put: (gcVal - gcStats at: idx)].
		"cancel the probe and return the value"
	Timer terminate.
	time := Time millisecondClockValue - time0.
	^value! !


!MessageTally class methodsFor: 'spying' stamp: 'ajh 4/15/2003 09:55'!
tallySendsTo: receiver inBlock: aBlock showTree: treeOption
	"MessageTally tallySends: [3.14159 printString]"
	"This method uses the simulator to count the number of calls on each method
	invoked in evaluating aBlock. If receiver is not nil, then only sends
	to that receiver are tallied.
	Results are presented as leaves, sorted by frequency,
	preceded, optionally, by the whole tree."
	| prev tallies startTime totalTime |
	startTime _ Time millisecondClockValue.
	tallies _ MessageTally new class: aBlock class
							method: aBlock method.
	prev _ aBlock.
	thisContext sender
		runSimulated: aBlock
		contextAtEachStep:
			[:current |
			current == prev ifFalse: 
				["call or return"
				prev sender == nil ifFalse: 
					["call only"
					(receiver == nil or: [current receiver == receiver])
						ifTrue: [tallies tally: current by: 1]].
				prev _ current]].

	totalTime _ Time millisecondClockValue - startTime // 1000.0 roundTo: 0.01.
	(StringHolder new contents:
		(String streamContents:
			[:s |
			s nextPutAll: 'This simulation took ' , totalTime printString
							, ' seconds.'; cr.
			treeOption
				ifTrue: [tallies fullPrintOn: s tallyExact: true orThreshold: 0]
				ifFalse: [tallies leavesPrintOn: s tallyExact: true orThreshold: 0].
			tallies close]))
		openLabel: 'Spy Results'! !


!Metaclass methodsFor: 'compiling' stamp: 'ajh 6/18/2002 14:48'!
holder

	^ nil -> self! !


!MethodContext methodsFor: 'accessing' stamp: 'ajh 1/31/2003 21:53'!
isClosureContext

	^ self isExecutingBlock! !

!MethodContext methodsFor: 'accessing' stamp: 'ajh 6/28/2004 00:32'!
isExecutingBlock
	"Is this executing a block versus a method"

	^ self method isBlockMethod! !

!MethodContext methodsFor: 'private' stamp: 'ajh 4/15/2003 10:03'!
asContext

	^ self! !

!MethodContext methodsFor: 'closure support' stamp: 'ajh 7/7/2004 15:14'!
capturedTempNames

	^ self methodNode scope capturedVars collect: [:var | var name]! !

!MethodContext methodsFor: 'closure support' stamp: 'ajh 7/7/2004 16:35'!
freeNames

	^ self methodNode freeNames! !

!MethodContext methodsFor: 'closure support' stamp: 'ajh 7/7/2004 17:49'!
freeNamesAndValues

	| aStream eval |
	eval _ [:string |
		self class evaluatorClass new
			evaluate2: (ReadStream on: string)
			in: self
			to: nil
			notifying: nil	"fix this"
			ifFail: [self error: 'bug']
			logged: false].

	aStream _ '' writeStream.
	self freeNames doWithIndex: [:name :index |
		aStream nextPutAll: name; nextPut: $:; space; tab.
		(eval value: name) printOn: aStream.
		aStream cr].
	^ aStream contents! !

!MethodContext methodsFor: 'closure support' stamp: 'ajh 6/29/2004 14:32'!
myEnv

	^ receiverMap! !

!MethodContext methodsFor: 'closure support' stamp: 'ajh 6/29/2004 14:32'!
myEnv: closureEnvironment

	receiverMap _ closureEnvironment! !

!MethodContext methodsFor: 'closure support' stamp: 'ajh 7/7/2004 15:28'!
tempsAndValues

	| string aStream |
	string _ super tempsAndValues.
	self myEnv ifNil: [^ string].

	aStream _ WriteStream on: (String new: 100).
	self capturedTempNames
		doWithIndex: [:title :index |
			aStream nextPutAll: title; nextPut: $:; space; tab.
			(self myEnv at: index) printOn: aStream.
			aStream cr].
	^ string, aStream contents! !


!MethodContext class methodsFor: 'instance creation' stamp: 'ajh 7/2/2004 13:50'!
myEnvFieldIndex

	^ self allInstVarNames indexOf: 'receiverMap'! !


!ParagraphEditor methodsFor: 'new selection' stamp: 'ajh 7/5/2004 16:10'!
notify: aString at: anInteger in: aStream 
	"The compilation of text failed. The syntax error is noted as the argument, 
	aString. Insert it in the text at starting character position anInteger."

	| pos |
	pos _ paragraph string = aStream originalContents
		ifTrue: [anInteger]
		ifFalse: [self startIndex + anInteger - 1].
	self insertAndSelect: aString at: (pos max: 1).
! !

