'From Squeak3.8alpha of ''17 July 2004'' [latest update: #6229] on 6 October 2004 at 5:05:48 pm'!
"Change Set:		CompilerExtras
Date:			20 May 2004
Author:			Anthony Hannan

Recompiler and closure stats for new closure compiler"!


!Bag methodsFor: 'acessing' stamp: 'ajh 5/21/2004 14:34'!
valuesAndCounts

	^ contents! !


!Categorizer methodsFor: 'printing' stamp: 'ajh 7/9/2004 16:12'!
printOn: aStream 
	"Refer to the comment in Object|printOn:."

	| elementIndex |
	elementIndex _ 1.
	1 to: categoryArray size do: 
		[:i | 
		aStream nextPut: $(.
		(categoryArray at: i) asString printOn: aStream.
		[elementIndex <= (categoryStops at: i)]
			whileTrue: 
				[aStream space; print: (elementArray at: elementIndex).
				elementIndex _ elementIndex + 1].
		aStream nextPut: $); cr]! !


!ClassOrganizer methodsFor: 'accessing' stamp: 'ajh 7/9/2004 16:11'!
changeFromCategorySpecs: categorySpecs

	| oldDict oldCategories |
	oldDict _ self elementCategoryDict.
	oldCategories _ self categories copy.
	SystemChangeNotifier uniqueInstance doSilently: [
		super changeFromCategorySpecs: categorySpecs].
	self notifyOfChangedSelectorsOldDict: oldDict newDict: self elementCategoryDict.
	self notifyOfChangedCategoriesFrom: oldCategories to: self categories.! !


!ContextPart methodsFor: 'query' stamp: 'ajh 6/6/2004 11:36'!
findSecondToOldestSimilarSender
	"Search the stack for the second-to-oldest occurance of self's method.  Very useful for an infinite recursion.  Gets back to the second call so you can see one complete recursion cycle, and how it was called at the beginning."

	| sec ctxt bot |
	sec _ self.
	ctxt _ self.
	[	bot _ ctxt findSimilarSender.
		bot isNil
	] whileFalse: [
		sec _ ctxt.
		ctxt _ bot.
	].
	^ sec
! !

!ContextPart methodsFor: 'query' stamp: 'ajh 6/6/2004 11:45'!
findSimilarSender
	"Return the closest sender with the same method, return nil if none found"

	| meth |
	meth _ self method.
	^ self sender findContextSuchThat: [:c | c method == meth]! !


!BlockContext methodsFor: 'printing'!
printOn: aStream

	home == nil ifTrue: [^aStream nextPutAll: 'a BlockContext with home=nil'].
	aStream nextPutAll: '[] in '.
	super printOn: aStream! !


!Debugger methodsFor: 'context stack (message list)' stamp: 'ajh 6/29/2004 14:31'!
selectedMessage
	"Answer the source code of the currently selected context."

	contents := theMethodNode sourceText asText.
	theMethodNode isDoIt ifFalse: [
		contents := contents makeSelectorBold].
	^ contents! !

!Debugger methodsFor: 'context stack menu' stamp: 'ajh 6/6/2004 11:38'!
peelToFirst
	"Peel the stack back to the second occurance of the currently selected message.  Very useful for an infinite recursion.  Gets back to the second call so you can see one complete recursion cycle, and how it was called at the beginning.  Also frees a lot of space!!"

	| ctxt |
	contextStackIndex = 0 ifTrue: [^ Beeper beep].
	"self okToChange ifFalse: [^ self]."
	ctxt _ interruptedProcess popTo: self selectedContext findSecondToOldestSimilarSender.
	self resetContext: ctxt.
! !

!Debugger methodsFor: 'code pane' stamp: 'ajh 7/12/2004 10:41'!
pcRange
	"Answer the indices in the source code for the method corresponding to 
	the selected context's program counter value."

	| i pc end |
	(selectingPC and: [contextStackIndex ~= 0])
		ifFalse: [^1 to: 0].
	sourceMap ifNil:
		[sourceMap _ theMethodNode sourceMap.
		tempNames _ theMethodNode tempNames.
		self selectedContext method cacheTempNames: tempNames].
	(sourceMap size = 0 or: [self selectedContext isDead]) ifTrue: [^ 1 to: 0].

	(theMethodNode isKindOf: RBProgramNode) ifTrue: [
		pc _ contextStackIndex = 1
			ifTrue: [self selectedContext pc]
			ifFalse: [self selectedContext previousPc].
		i _ sourceMap findLast: [:pcRange | pcRange key <= pc].
		i = 0 ifTrue:[^ 1 to: 0].
		^ (sourceMap at: i) value
	].

	pc_ self selectedContext pc -
		(("externalInterrupt" true and: [contextStackIndex=1])
			ifTrue: [1]
			ifFalse: [2]).
	i _ sourceMap indexForInserting: (Association key: pc value: nil).
	i < 1 ifTrue: [^1 to: 0].
	i > sourceMap size
		ifTrue:
			[end _ sourceMap inject: 0 into:
				[:prev :this | prev max: this value last].
			^ end+1 to: end].
	^(sourceMap at: i) value! !


!ProcessBrowser methodsFor: 'stack list' stamp: 'ajh 7/12/2004 10:45'!
pcRange
	"Answer the indices in the source code for the method corresponding to  
	the selected context's program counter value."
	| i methodNode pc end tempNames |
	methodText isEmptyOrNil
		ifTrue: [^ 1 to: 0].
	sourceMap == nil
		ifTrue: [self selectedClass == #unknown
				ifTrue: [^ 1 to: 0].
			[[methodNode _ self selectedClass compilerClass new
						parse: methodText
						in: self selectedClass
						notifying: self ]
				on: Warning
				do: [:ex | 
					methodText _ ('(syntax error) ' , ex description , String cr , methodText) asText.
					ex return]]
				on: Error
				do: [:ex | 
					methodText _ ('(parse error) ' , ex description , String cr , methodText) asText.
					ex return].
			methodNode
				ifNil: [sourceMap _ nil.
					^ 1 to: 0].
			sourceMap _ methodNode sourceMap.
			tempNames _ methodNode tempNames.
			selectedContext method cacheTempNames: tempNames].
	(sourceMap size = 0 or: [ selectedContext isDead ])
		ifTrue: [^ 1 to: 0].

	(methodNode isKindOf: RBProgramNode) ifTrue: [
		pc _ stackListIndex = 1
			ifTrue: [selectedContext pc]
			ifFalse: [selectedContext previousPc].
		i _ sourceMap findLast: [:pcRange | pcRange key <= pc].
		i = 0 ifTrue:[^ 1 to: 0].
		^ (sourceMap at: i) value
	].

	pc _ selectedContext pc.
	pc _ pc - 2.
	i _ sourceMap
				indexForInserting: (Association key: pc value: nil).
	i < 1
		ifTrue: [^ 1 to: 0].
	i > sourceMap size
		ifTrue: [end _ sourceMap
						inject: 0
						into: [:prev :this | prev max: this value last].
			^ end + 1 to: end].
	^ (sourceMap at: i) value! !

